# all files / src/mixins/ ButtonElement.js

63.24% Statements 43/68
26.53% Branches 13/49
50% Functions 6/12
63.24% Lines 43/68

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259

    1×

    10935×

    10935×
    10935×
    10935×
    10935×
    10935×
    10935×
    10935×
    10935×
    10935×

    10935×
    10935×
    10935×

    1×

    1×

    1×
    10935×

    10935×

    10935×
    7719×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
    42400×

    1×
    10944×
    10944×
    10935×
    10935×

    10935×

    10944×

    1×
    7719×
    7719×
    7719×
    7719×

    1×
    42400×

     /**
     * ButtonElement is often mixed into other classes to generate a button, which is a clickable
     * interface element that can be configured with access keys for accessibility.
     * See the [OOUI documentation on MediaWiki] [1] for examples.
     *
     * [1]: https://www.mediawiki.org/wiki/OOUI/Widgets/Buttons_and_Switches#Buttons
     *
     * @abstract
     * @class
     *
     * @constructor
     * @param {Object} [config] Configuration options
     * @cfg {jQuery} [$button] The button element created by the class.
     *  If this configuration is omitted, the button element will use a generated `<a>`.
     * @cfg {boolean} [framed=true] Render the button with a frame
     */
    OO.ui.mixin.ButtonElement = function OoUiMixinButtonElement( config ) {
    	// Configuration initialization
    	config = config || {};

    	// Properties
    	this.$button = null;
    	this.framed = null;
    	this.active = config.active !== undefined && config.active;
    	this.onMouseUpHandler = this.onMouseUp.bind( this );
    	this.onMouseDownHandler = this.onMouseDown.bind( this );
    	this.onKeyDownHandler = this.onKeyDown.bind( this );
    	this.onKeyUpHandler = this.onKeyUp.bind( this );
    	this.onClickHandler = this.onClick.bind( this );
    	this.onKeyPressHandler = this.onKeyPress.bind( this );

    	// Initialization
    	this.$element.addClass( 'oo-ui-buttonElement' );
    	this.toggleFramed( config.framed === undefined || config.framed );
    	this.setButtonElement( config.$button || $( '<a>' ) );
    };

    /* Setup */

    OO.initClass( OO.ui.mixin.ButtonElement );

    /* Static Properties */

    /**
     * Cancel mouse down events.
     *
     * This property is usually set to `true` to prevent the focus from changing when the button is clicked.
     * Classes such as {@link OO.ui.mixin.DraggableElement DraggableElement} and {@link OO.ui.ButtonOptionWidget ButtonOptionWidget}
     * use a value of `false` so that dragging behavior is possible and mousedown events can be handled by a
     * parent widget.
     *
     * @static
     * @inheritable
     * @property {boolean}
     */
    OO.ui.mixin.ButtonElement.static.cancelButtonMouseDownEvents = true;

    /* Events */

    /**
     * A 'click' event is emitted when the button element is clicked.
     *
     * @event click
     */

    /* Methods */

    /**
     * Set the button element.
     *
     * This method is used to retarget a button mixin so that its functionality applies to
     * the specified button element instead of the one created by the class. If a button element
     * is already set, the method will remove the mixin’s effect on that element.
     *
     * @param {jQuery} $button Element to use as button
     */
    OO.ui.mixin.ButtonElement.prototype.setButtonElement = function ( $button ) {
    	Iif ( this.$button ) {
    		this.$button
    			.removeClass( 'oo-ui-buttonElement-button' )
    			.removeAttr( 'role accesskey' )
    			.off( {
    				mousedown: this.onMouseDownHandler,
    				keydown: this.onKeyDownHandler,
    				click: this.onClickHandler,
    				keypress: this.onKeyPressHandler
    			} );
    	}

    	this.$button = $button
    		.addClass( 'oo-ui-buttonElement-button' )
    		.on( {
    			mousedown: this.onMouseDownHandler,
    			keydown: this.onKeyDownHandler,
    			click: this.onClickHandler,
    			keypress: this.onKeyPressHandler
    		} );

    	// Add `role="button"` on `<a>` elements, where it's needed
    	// `toUppercase()` is added for XHTML documents
    	if ( this.$button.prop( 'tagName' ).toUpperCase() === 'A' ) {
    		this.$button.attr( 'role', 'button' );
    	}
    };

    /**
     * Handles mouse down events.
     *
     * @protected
     * @param {jQuery.Event} e Mouse down event
     */
    OO.ui.mixin.ButtonElement.prototype.onMouseDown = function ( e ) {
    	if ( this.isDisabled() || e.which !== OO.ui.MouseButtons.LEFT ) {
    		return;
    	}
    	this.$element.addClass( 'oo-ui-buttonElement-pressed' );
    	// Run the mouseup handler no matter where the mouse is when the button is let go, so we can
    	// reliably remove the pressed class
    	this.getElementDocument().addEventListener( 'mouseup', this.onMouseUpHandler, true );
    	// Prevent change of focus unless specifically configured otherwise
    	if ( this.constructor.static.cancelButtonMouseDownEvents ) {
    		return false;
    	}
    };

    /**
     * Handles mouse up events.
     *
     * @protected
     * @param {MouseEvent} e Mouse up event
     */
    OO.ui.mixin.ButtonElement.prototype.onMouseUp = function ( e ) {
    	if ( this.isDisabled() || e.which !== OO.ui.MouseButtons.LEFT ) {
    		return;
    	}
    	this.$element.removeClass( 'oo-ui-buttonElement-pressed' );
    	// Stop listening for mouseup, since we only needed this once
    	this.getElementDocument().removeEventListener( 'mouseup', this.onMouseUpHandler, true );
    };

    /**
     * Handles mouse click events.
     *
     * @protected
     * @param {jQuery.Event} e Mouse click event
     * @fires click
     */
    OO.ui.mixin.ButtonElement.prototype.onClick = function ( e ) {
    	if ( !this.isDisabled() && e.which === OO.ui.MouseButtons.LEFT ) {
    		if ( this.emit( 'click' ) ) {
    			return false;
    		}
    	}
    };

    /**
     * Handles key down events.
     *
     * @protected
     * @param {jQuery.Event} e Key down event
     */
    OO.ui.mixin.ButtonElement.prototype.onKeyDown = function ( e ) {
    	if ( this.isDisabled() || ( e.which !== OO.ui.Keys.SPACE && e.which !== OO.ui.Keys.ENTER ) ) {
    		return;
    	}
    	this.$element.addClass( 'oo-ui-buttonElement-pressed' );
    	// Run the keyup handler no matter where the key is when the button is let go, so we can
    	// reliably remove the pressed class
    	this.getElementDocument().addEventListener( 'keyup', this.onKeyUpHandler, true );
    };

    /**
     * Handles key up events.
     *
     * @protected
     * @param {KeyboardEvent} e Key up event
     */
    OO.ui.mixin.ButtonElement.prototype.onKeyUp = function ( e ) {
    	if ( this.isDisabled() || ( e.which !== OO.ui.Keys.SPACE && e.which !== OO.ui.Keys.ENTER ) ) {
    		return;
    	}
    	this.$element.removeClass( 'oo-ui-buttonElement-pressed' );
    	// Stop listening for keyup, since we only needed this once
    	this.getElementDocument().removeEventListener( 'keyup', this.onKeyUpHandler, true );
    };

    /**
     * Handles key press events.
     *
     * @protected
     * @param {jQuery.Event} e Key press event
     * @fires click
     */
    OO.ui.mixin.ButtonElement.prototype.onKeyPress = function ( e ) {
    	if ( !this.isDisabled() && ( e.which === OO.ui.Keys.SPACE || e.which === OO.ui.Keys.ENTER ) ) {
    		if ( this.emit( 'click' ) ) {
    			return false;
    		}
    	}
    };

    /**
     * Check if button has a frame.
     *
     * @return {boolean} Button is framed
     */
    OO.ui.mixin.ButtonElement.prototype.isFramed = function () {
    	return this.framed;
    };

    /**
     * Render the button with or without a frame. Omit the `framed` parameter to toggle the button frame on and off.
     *
     * @param {boolean} [framed] Make button framed, omit to toggle
     * @chainable
     */
    OO.ui.mixin.ButtonElement.prototype.toggleFramed = function ( framed ) {
    	framed = framed === undefined ? !this.framed : !!framed;
    	if ( framed !== this.framed ) {
    		this.framed = framed;
    		this.$element
    			.toggleClass( 'oo-ui-buttonElement-frameless', !framed )
    			.toggleClass( 'oo-ui-buttonElement-framed', framed );
    		this.updateThemeClasses();
    	}

    	return this;
    };

    /**
     * Set the button's active state.
     *
     * The active state can be set on:
     *
     *  - {@link OO.ui.ButtonOptionWidget ButtonOptionWidget} when it is selected
     *  - {@link OO.ui.ToggleButtonWidget ToggleButtonWidget} when it is toggle on
     *  - {@link OO.ui.ButtonWidget ButtonWidget} when clicking the button would only refresh the page
     *
     * @protected
     * @param {boolean} value Make button active
     * @chainable
     */
    OO.ui.mixin.ButtonElement.prototype.setActive = function ( value ) {
    	this.active = !!value;
    	this.$element.toggleClass( 'oo-ui-buttonElement-active', this.active );
    	this.updateThemeClasses();
    	return this;
    };

    /**
     * Check if the button is active
     *
     * @protected
     * @return {boolean} The button is active
     */
    OO.ui.mixin.ButtonElement.prototype.isActive = function () {
    	return this.active;
    };